"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var styled_components_1 = __importDefault(require("styled-components"));
var Buttons_1 = require("../styles/Buttons");
var AOIModal = function (_a) {
    var AOIModalType = _a.AOIModalType, AOIdata = _a.AOIdata, onClose = _a.onClose, onSaveAoi = _a.onSaveAoi;
    var _b = (0, react_1.useState)(function () {
        if (AOIModalType === "fix" && AOIdata) {
            return __assign({}, AOIdata);
        }
        else {
            return {
                left: 0,
                top: 0,
                width: 0,
                height: 0,
                name: "",
            };
        }
    }), AOI = _b[0], setAOI = _b[1];
    var canvasRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        var canvas = canvasRef.current;
        if (!canvas) {
            return;
        }
        var mousedown = false;
        var start_x = 0;
        var start_y = 0;
        var end_x = 0;
        var end_y = 0;
        var ctx = canvas.getContext("2d");
        if (!ctx) {
            return;
        }
        var drawrect = function (x, y, width, height, color) {
            if (!canvas || !ctx) {
                return;
            }
            ctx.beginPath();
            //   console.log(x + '/' + y + '///' + width + '/' + height);
            ctx.strokeStyle = color; //테두리색
            ctx.lineWidth = 2;
            ctx.strokeRect(x, y, width, height);
            ctx.stroke();
        };
        var undraw = function () {
            if (!canvas || !ctx) {
                return;
            }
            ctx.clearRect(0, 0, canvas.width, canvas.height);
            ctx.beginPath();
        };
        var md = function (e) {
            undraw();
            mousedown = true;
            start_x = e.offsetX;
            start_y = e.offsetY;
        };
        var mu = function (e) {
            if (mousedown) {
                undraw();
                mousedown = false;
                end_x = e.offsetX;
                end_y = e.offsetY;
                var left = start_x < end_x ? start_x : end_x; //left
                var top_1 = start_y < end_y ? start_y : end_y; //top
                var width = left !== start_x ? start_x - end_x : end_x - start_x;
                var height = top_1 !== start_y ? start_y - end_y : end_y - start_y;
                setAOI(__assign(__assign({}, AOI), { left: +(left / 740).toFixed(3), top: +(top_1 / 740).toFixed(3), width: +(width / 740).toFixed(3), height: +(height / 740).toFixed(3) }));
            }
        };
        var mm = function (e) {
            if (mousedown) {
                undraw();
                var tmp_x = e.offsetX;
                var tmp_y = e.offsetY;
                var width = tmp_x - start_x;
                var height = tmp_y - start_y;
                drawrect(start_x, start_y, width, height, "green");
            }
        };
        var mo = function (e) {
            if (mousedown) {
                mousedown = false;
                undraw();
                end_x = e.offsetX;
                end_y = e.offsetY;
                // console.log(end_x);
                var left = start_x < end_x ? start_x : end_x; //left
                var top_2 = start_y < end_y ? start_y : end_y; //top
                var width = left !== start_x ? start_x - end_x : end_x - start_x;
                var height = top_2 !== start_y ? start_y - end_y : end_y - start_y;
                setAOI(__assign(__assign({}, AOI), { left: +(left / 740).toFixed(3) < 0 ? 0 : +(left / 740).toFixed(3), top: +(top_2 / 740).toFixed(3) < 0 ? 0 : +(top_2 / 740).toFixed(3), width: +(width / 740).toFixed(3), height: +(height / 740).toFixed(3) }));
            }
        };
        //console.log(AOI);
        var drawname = function (x, y, width, height, color, name) {
            if (!canvas || !ctx) {
                return;
            }
            ctx.beginPath();
            ctx.font = "20px Arial";
            ctx.fillStyle = color;
            var textbackwidth = ctx.measureText(name).width;
            ctx.fillRect(x, y - 20, textbackwidth + 10, 22);
            ctx.fillStyle = "white";
            ctx.fillText(name, x + 5, y - 1);
            ctx.stroke();
        };
        var drawmsg = function (msg) {
            if (!canvas || !ctx) {
                return;
            }
            ctx.beginPath();
            ctx.font = "40px Arial";
            ctx.fillStyle = "red";
            var textbackwidth = ctx.measureText(msg).width;
            var x = (740 - textbackwidth) / 2;
            x = x < 0 ? 0 : x;
            var y = 320;
            ctx.fillRect(x, y - 40, textbackwidth + 10, 44);
            ctx.fillStyle = "white";
            ctx.fillText(msg, x + 5, y - 2);
            ctx.stroke();
        };
        undraw();
        if (AOI.left > 0 && AOI.top > 0 && AOI.width > 0 && AOI.height > 0) {
            drawrect(AOI.left * 740, AOI.top * 740, AOI.width * 740, AOI.height * 740, "#0000ff");
            if (AOI.name) {
                drawname(AOI.left * 740, AOI.top * 740, AOI.width * 740, AOI.height * 740, "#0000ff", AOI.name);
            }
            else {
                drawname(AOI.left * 740, AOI.top * 740, AOI.width * 740, AOI.height * 740, "#ff0000", "핵심영역 이름을 정해주세요");
            }
        }
        canvas.addEventListener("mousedown", md);
        canvas.addEventListener("mouseup", mu);
        canvas.addEventListener("mousemove", mm);
        canvas.addEventListener("mouseout", mo);
        return function () {
            canvas === null || canvas === void 0 ? void 0 : canvas.removeEventListener("mousedown", md);
            canvas === null || canvas === void 0 ? void 0 : canvas.removeEventListener("mouseup", mu);
            canvas === null || canvas === void 0 ? void 0 : canvas.removeEventListener("mousemove", mm);
            canvas === null || canvas === void 0 ? void 0 : canvas.removeEventListener("mouseout", mo);
        };
    }, [AOI]);
    return ((0, jsx_runtime_1.jsxs)(StyledModal, __assign({ className: "no-drag" }, { children: [(0, jsx_runtime_1.jsx)(StyledDark, {}), (0, jsx_runtime_1.jsxs)(StyledContents, { children: [(0, jsx_runtime_1.jsxs)(StyledInfoBox, { children: [(0, jsx_runtime_1.jsx)(StyledInputWrap, { children: (0, jsx_runtime_1.jsx)(StyledInputText, { type: "text", value: AOI.name, placeholder: "\uD575\uC2EC\uC601\uC5ED \uC774\uB984", onChange: function (e) {
                                        setAOI(function (state) { return (__assign(__assign({}, state), { name: e.target.value })); });
                                    } }) }), (0, jsx_runtime_1.jsxs)(StyledButtons, { children: [(0, jsx_runtime_1.jsxs)(Buttons_1.StyledBtn, __assign({ disabled: !AOI.height || !AOI.name ? true : false, onClick: function () {
                                            onSaveAoi(AOI);
                                        } }, { children: ["\uC601\uC5ED ", AOIModalType === "add" ? "추가" : "수정"] })), (0, jsx_runtime_1.jsx)(Buttons_1.StyledBtnRed, __assign({ onClick: onClose, style: { marginLeft: "10px" } }, { children: "\uCDE8\uC18C" }))] })] }), (0, jsx_runtime_1.jsx)(StyledCanvasWrap, { children: (0, jsx_runtime_1.jsx)(StyledCanvas, { ref: canvasRef, width: 740, height: 740, style: { width: "100%", height: "100%" } }) }), !(AOI.left > 0 && AOI.top > 0 && AOI.width > 0 && AOI.height > 0) && ((0, jsx_runtime_1.jsx)(StyledDragInfo, { children: "\uD575\uC2EC\uC601\uC5ED\uC744 \uB9C8\uC6B0\uC2A4\uB85C \uB4DC\uB798\uADF8 \uD574\uC8FC\uC138\uC694" }))] })] })));
};
exports.default = AOIModal;
var StyledModal = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n\n  display: flex;\n  justify-content: center;\n  align-items: center;\n"], ["\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n\n  display: flex;\n  justify-content: center;\n  align-items: center;\n"])));
var StyledDark = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  position: fixed;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  background-color: rgba(0, 0, 0, 0.7);\n  z-index: 1;\n"], ["\n  position: fixed;\n  left: 0;\n  top: 0;\n  width: 100%;\n  height: 100%;\n  background-color: rgba(0, 0, 0, 0.7);\n  z-index: 1;\n"])));
var StyledContents = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  width: 100%;\n  height: 100%;\n  /*    border:1px solid black;*/\n  background-color: transparent;\n  outline: 3px solid #fff;\n  /*    border:1px solid black;*/\n  position: relative;\n  z-index: 1002;\n"], ["\n  width: 100%;\n  height: 100%;\n  /*    border:1px solid black;*/\n  background-color: transparent;\n  outline: 3px solid #fff;\n  /*    border:1px solid black;*/\n  position: relative;\n  z-index: 1002;\n"])));
var StyledInfoBox = styled_components_1.default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  z-index: 1001;\n  position: absolute;\n  border-radius: 5px;\n  background-color: #fff;\n  top: calc(100% - 130px);\n  left: calc(100% + 10px); /*  */\n  height: 130px;\n  width: 270px;\n  padding: 10px !important;\n  display: flex;\n  flex-direction: column;\n  gap: 10px;\n\n  font-size: 22px;\n  font-weight: 700;\n\n  position: relative;\n"], ["\n  z-index: 1001;\n  position: absolute;\n  border-radius: 5px;\n  background-color: #fff;\n  top: calc(100% - 130px);\n  left: calc(100% + 10px); /*  */\n  height: 130px;\n  width: 270px;\n  padding: 10px !important;\n  display: flex;\n  flex-direction: column;\n  gap: 10px;\n\n  font-size: 22px;\n  font-weight: 700;\n\n  position: relative;\n"])));
var StyledInputWrap = styled_components_1.default.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  width: 100%;\n  height: 50px;\n"], ["\n  width: 100%;\n  height: 50px;\n"])));
var StyledInputText = styled_components_1.default.input(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  width: 100%;\n  height: 100%;\n  outline: none;\n  border-radius: 4px;\n  border: 1px solid rgb(200, 200, 200);\n  padding-left: 10px !important;\n  cursor: pointer;\n  box-sizing: border-box;\n"], ["\n  width: 100%;\n  height: 100%;\n  outline: none;\n  border-radius: 4px;\n  border: 1px solid rgb(200, 200, 200);\n  padding-left: 10px !important;\n  cursor: pointer;\n  box-sizing: border-box;\n"])));
var StyledButtons = styled_components_1.default.div(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  display: flex;\n  height: 50px;\n  justify-content: flex-end;\n  align-items: center;\n"], ["\n  display: flex;\n  height: 50px;\n  justify-content: flex-end;\n  align-items: center;\n"])));
var StyledCanvasWrap = styled_components_1.default.div(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  z-index: 1001;\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 740px;\n  height: 740px;\n"], ["\n  z-index: 1001;\n  position: absolute;\n  left: 0;\n  top: 0;\n  width: 740px;\n  height: 740px;\n"])));
var StyledCanvas = styled_components_1.default.canvas(templateObject_9 || (templateObject_9 = __makeTemplateObject(["\n  cursor: crosshair;\n"], ["\n  cursor: crosshair;\n"])));
var StyledDragInfo = styled_components_1.default.div(templateObject_10 || (templateObject_10 = __makeTemplateObject(["\n  position: absolute;\n  top: -55px;\n  left: 50%;\n  transform: translateX(-50%);\n  width: 60%;\n  height: 50px;\n  font-size: 24px;\n  font-weight: 700;\n  margin: 0 auto;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  background: red;\n  color: white;\n  z-index: 1000;\n"], ["\n  position: absolute;\n  top: -55px;\n  left: 50%;\n  transform: translateX(-50%);\n  width: 60%;\n  height: 50px;\n  font-size: 24px;\n  font-weight: 700;\n  margin: 0 auto;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  background: red;\n  color: white;\n  z-index: 1000;\n"])));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10;
